/*

    Copyright (C) 2010-2012  DAHMEN, Manuel, Daniel

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

*/

package be.ibiiztera.md.pmatrix.starbuck02;

import be.ibiiztera.md.pmatrix.pushmatrix.Scene;
import java.awt.Dimension;
import java.awt.Point;
import javax.swing.JPanel;

/**
 *
 * @author Manuel DAHMEN
 */
public class View4 extends javax.swing.JFrame {
    private final RenderPreviewPanel rpp1;
    private final RenderPreviewPanel rpp2;
    private final RenderPreviewPanel rpp3;
    private final RenderPreviewPanel rpp4;
    private final PreviewControleurConcrete pc1;
    private final PreviewControleurConcrete pc2;
    private final PreviewControleurConcrete pc3;
    private final PreviewControleurConcrete pc4;

    /**
     * Creates new form View4
     */
    public View4() {
        setMinimumSize(new Dimension(600,600));
        initComponents();
        
        
        pc1 = new PreviewControleurConcrete();
        pc2 = new PreviewControleurConcrete();
        pc3 = new PreviewControleurConcrete();
        pc4 = new PreviewControleurConcrete();
        rpp1 = new RenderPreviewPanel();
        JPanel p;
        p = new JPanel();
        rpp1.setLocation(new Point( 300, 300));
        rpp1.setMinimumSize(new Dimension(300,300));
        p.add(rpp1);
        rpp1.setView(pc1);
        this.add(rpp1);
        
        
        rpp2 = new RenderPreviewPanel();
        p = new JPanel();
        rpp2.setLocation(new Point( 300, 0));
        rpp2.setMinimumSize(new Dimension(300,300));
        p.add(rpp2);
        rpp2.setView(pc2);
        this.add(rpp2);
        
        
        rpp3 = new RenderPreviewPanel();
        p = new JPanel();
        rpp3.setLocation(new Point( 300, 300));
        rpp3.setMinimumSize(new Dimension(300,300));
        p.add(rpp3);
        rpp3.setView(pc3);
        this.add(rpp3);
        
        
        rpp4 = new RenderPreviewPanel();
        p = new JPanel();
        rpp4.setLocation(new Point(300, 300));
        rpp4.setMinimumSize(new Dimension(300,300));
        p.add(rpp4);
        rpp4.setView(pc4);
        this.add(rpp4);
        

        rpp1.run();
        rpp2.run();
        rpp3.run();
        rpp4.run();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 404, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 379, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(View4.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(View4.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(View4.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(View4.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the form
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                new View4().setVisible(true);
            }
        });
    }
    
    public void addModel(Scene sc)
    {
        pc1.assignerModele(sc);
        pc2.assignerModele(sc);
        pc3.assignerModele(sc);
        pc4.assignerModele(sc);
    }       
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
}
